// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Modlink.pas' rev: 10.00

#ifndef ModlinkHPP
#define ModlinkHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Modlink
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS EModLinkError;
class PASCALIMPLEMENTATION EModLinkError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EModLinkError(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EModLinkError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EModLinkError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EModLinkError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EModLinkError(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EModLinkError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EModLinkError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EModLinkError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EModLinkError(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TSeekMode { smBufStart, smBufEnd, smPriorByte, smNextByte, smPriorWord, smNextWord };
#pragma option pop

class DELPHICLASS TModbusBuffer;
class PASCALIMPLEMENTATION TModbusBuffer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FCapacity;
	char *FCurPtr;
	char *FPeakPtr;
	char *FStartPtr;
	void __fastcall CheckAvailableSpace(int SizeOfData);
	int __fastcall GetSize(void);
	int __fastcall GetPosition(void);
	void __fastcall SetPosition(int Value);
	void __fastcall SetSize(int Value);
	
public:
	__fastcall TModbusBuffer(int ACapacity);
	__fastcall virtual ~TModbusBuffer(void);
	Word __fastcall CRC16(void);
	void __fastcall CutLeadingBytesOff(void);
	void __fastcall GetBlock(void *Buffer, int BlockSize);
	Byte __fastcall GetByte(void);
	Word __fastcall GetWordHiLo(void);
	Word __fastcall GetWordLoHi(void);
	Byte __fastcall LRC8(void);
	void __fastcall PutBlock(const void *Buffer, int BlockSize);
	void __fastcall PutByte(Byte Data);
	void __fastcall PutWordHiLo(Word Data);
	void __fastcall PutWordLoHi(Word Data);
	void __fastcall Seek(TSeekMode Mode);
	__property int Capacity = {read=FCapacity, nodefault};
	__property int Position = {read=GetPosition, write=SetPosition, nodefault};
	__property int Size = {read=GetSize, write=SetSize, nodefault};
	__property char * StartPtr = {read=FStartPtr};
};


#pragma option push -b-
enum TServerReply { srNone, srUnmatchedReply, srExceptionReply, srNormalReply };
#pragma option pop

#pragma option push -b-
enum TServerException { seUnknown, seIllegalCommand, seIllegalDataAddress, seIllegalDataValue, seServerFailure, seAcknowledge, seServerBusy, seNegativeAcknowledge, seMemoryParityError };
#pragma option pop

struct TTransactionInfo
{
	
public:
	unsigned ID;
	Byte Address;
	void *UserData;
	unsigned Retries;
	TServerReply Reply;
	TServerException Exception;
	Byte ExceptionCode;
} ;

class DELPHICLASS TModbusTransaction;
class PASCALIMPLEMENTATION TModbusTransaction : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TModbusBuffer* FQueryBuffer;
	TModbusBuffer* FReplyBuffer;
	
public:
	bool Custom;
	TTransactionInfo Info;
	bool Promiscuous;
	__fastcall TModbusTransaction(unsigned BufCapacity);
	__fastcall virtual ~TModbusTransaction(void);
	__property TModbusBuffer* QueryBuffer = {read=FQueryBuffer};
	__property TModbusBuffer* ReplyBuffer = {read=FReplyBuffer};
};


typedef DynamicArray<bool >  TBitValues;

class DELPHICLASS TModbusClient;
typedef void __fastcall (__closure *TMultipleBitsAccessEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Word StartBit, Word BitCount, const TBitValues BitValues);

typedef void __fastcall (__closure *TSingleCoilWriteEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Word BitAddr, bool BitValue);

typedef DynamicArray<Word >  TRegValues;

typedef void __fastcall (__closure *TMultipleRegistersAccessEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Word StartReg, Word RegCount, const TRegValues RegValues);

typedef void __fastcall (__closure *TSingleRegisterWriteEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Word RegAddr, Word RegValue);

typedef void __fastcall (__closure *TSingleRegisterMaskWriteEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Word RegAddr, Word AndMask, Word OrMask);

class DELPHICLASS TModbusFileRecord;
class PASCALIMPLEMENTATION TModbusFileRecord : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	Word operator[](int Index) { return RegValues[Index]; }
	
private:
	Word FFileID;
	DynamicArray<Word >  FRegValues;
	Word FStartReg;
	int __fastcall GetRegCount(void);
	Word __fastcall GetRegValue(int Index);
	void __fastcall SetRegCount(int Value);
	void __fastcall SetRegValue(int Index, Word Value);
	void __fastcall SetStartReg(Word Value);
	
public:
	__fastcall TModbusFileRecord(Word AFileID, Word AStartReg, int ARegCount);
	__fastcall virtual ~TModbusFileRecord(void);
	void __fastcall AdjustRange(Word AStartReg, int ARegCount);
	__property Word FileID = {read=FFileID, write=FFileID, nodefault};
	__property int RegCount = {read=GetRegCount, write=SetRegCount, nodefault};
	__property Word RegValues[int Index] = {read=GetRegValue, write=SetRegValue/*, default*/};
	__property Word StartReg = {read=FStartReg, write=SetStartReg, nodefault};
};


class DELPHICLASS TModbusFileRecordList;
class PASCALIMPLEMENTATION TModbusFileRecordList : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TModbusFileRecord* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TList* FList;
	int __fastcall GetCount(void);
	TModbusFileRecord* __fastcall GetItem(int Index);
	
public:
	__fastcall TModbusFileRecordList(void);
	__fastcall virtual ~TModbusFileRecordList(void);
	TModbusFileRecord* __fastcall Add(Word AFileID, Word AStartReg, int ARegCount)/* overload */;
	TModbusFileRecord* __fastcall Add(Word AFileID, Word AStartReg, Word const * ARegValues, const int ARegValues_Size)/* overload */;
	void __fastcall Clear(void);
	void __fastcall Delete(int Index);
	int __fastcall Remove(TModbusFileRecord* FileRecord);
	__property int Count = {read=GetCount, nodefault};
	__property TModbusFileRecord* Items[int Index] = {read=GetItem/*, default*/};
};


typedef void __fastcall (__closure *TFileRecordAccessEvent)(TModbusClient* Sender, const TTransactionInfo &Info, TModbusFileRecordList* FileRecList);

typedef DynamicArray<bool >  TExceptionStatusValues;

typedef void __fastcall (__closure *TExceptionStatusReadEvent)(TModbusClient* Sender, const TTransactionInfo &Info, const TExceptionStatusValues StatusValues);

typedef DynamicArray<Byte >  TServerIdentificationData;

typedef void __fastcall (__closure *TServerIdentificationReportEvent)(TModbusClient* Sender, const TTransactionInfo &Info, int Count, const TServerIdentificationData Data);

#pragma option push -b-
enum TDiagnosticAction { daReturnQueryData, daRestartCommsOption, daRestartCommsOptionAndClearEventLog, daReturnDiagnosticRegister, daForceListenOnlyMode, daClearCountersAndDiagnosticRegister, daReturnBusMessageCount, daReturnBusCommErrorCount, daReturnBusExceptionErrorCount, daReturnServerMessageCount, daReturnServerNoReplyCount, daReturnServerNegativeAcknowledgeCount, daReturnServerBusyCount, daReturnBusCharacterOverrunCount, daClearOverrunCounterAndFlag };
#pragma option pop

typedef void __fastcall (__closure *TDiagnosticsEvent)(TModbusClient* Sender, const TTransactionInfo &Info, TDiagnosticAction Action, Word Result);

typedef void __fastcall (__closure *TCustomTransactionCompleteEvent)(TModbusClient* Sender, const TTransactionInfo &Info, Byte Command, const AnsiString RequestData, const AnsiString ResponseData);

typedef void __fastcall (__closure *TTranslateExceptionCodeEvent)(TModbusClient* Sender, Byte ExceptionCode, AnsiString &Description);

class DELPHICLASS TModbusConnection;
#pragma option push -b-
enum TBaudRate { br110, br300, br600, br1200, br2400, br4800, br9600, br14400, br19200, br38400, br56000, br57600, br115200, br128000, br256000, brCustom };
#pragma option pop

#pragma option push -b-
enum TConnectionMode { cmClient, cmServer };
#pragma option pop

#pragma option push -b-
enum TDataBits { db7, db8 };
#pragma option pop

#pragma option push -b-
enum TFlowControl { fcNone, fcRtsToggle, fcRtsCts, fcDtrDsr };
#pragma option pop

typedef unsigned TMaxRetries;

typedef DynamicArray<Byte >  TFrameData;

typedef void __fastcall (__closure *TFrameDataEvent)(TModbusConnection* Sender, const TFrameData Data);

typedef void __fastcall (__closure *TGetHookedPortHandleEvent)(TModbusConnection* Sender, unsigned &HookHandle);

#pragma option push -b-
enum TParityScheme { psNone, psOdd, psEven };
#pragma option pop

typedef AnsiString TSerialPort;

#pragma option push -b-
enum TStopBits { sb1, sb2 };
#pragma option pop

#pragma option push -b-
enum TTransmissionMode { tmRTU, tmASCII };
#pragma option pop

class DELPHICLASS TModbusServer;
class PASCALIMPLEMENTATION TModbusConnection : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	TBaudRate FBaudRate;
	unsigned FBreakEvent;
	Classes::TList* FClientList;
	TConnectionMode FConnectionMode;
	unsigned FCustomBaudRate;
	TDataBits FDataBits;
	unsigned FDeviceHandle;
	bool FDTREnabled;
	bool FEchoQueryBeforeReply;
	TFlowControl FFlowControl;
	bool FHookExistingPort;
	HWND FInternalWindow;
	Sysutils::TMultiReadExclusiveWriteSynchronizer* FLock;
	TMaxRetries FMaxRetries;
	unsigned FNextUniqueID;
	Classes::TNotifyEvent FOnAfterClose;
	Classes::TNotifyEvent FOnAfterOpen;
	Classes::TNotifyEvent FOnBeforeClose;
	Classes::TNotifyEvent FOnBeforeOpen;
	TFrameDataEvent FOnFrameReceive;
	TFrameDataEvent FOnFrameSend;
	TGetHookedPortHandleEvent FOnGetHookedPortHandle;
	unsigned FOverlappedEvent;
	TParityScheme FParity;
	AnsiString FPort;
	unsigned FRealSilentInterval;
	unsigned FReceiveTimeout;
	unsigned FRefetchDelay;
	bool FRTSEnabled;
	Classes::TList* FServerList;
	unsigned FSilentInterval;
	TStopBits FStopBits;
	bool FStreamedActive;
	Classes::TThread* FThread;
	Classes::TThreadPriority FThreadPriority;
	TTransmissionMode FTransmissionMode;
	unsigned FSendTimeout;
	unsigned FTurnaroundDelay;
	void __fastcall UpdateRealSilentInterval(void);
	TModbusClient* __fastcall GetClient(int Index);
	int __fastcall GetClientCount(void);
	TMaxRetries __fastcall GetMaxRetries(void);
	unsigned __fastcall GetRealSilentInterval(void);
	unsigned __fastcall GetReceiveTimeout(void);
	unsigned __fastcall GetRefetchDelay(void);
	unsigned __fastcall GetSendTimeout(void);
	TModbusServer* __fastcall GetServer(int Index);
	int __fastcall GetServerCount(void);
	unsigned __fastcall GetTurnaroundDelay(void);
	void __fastcall InternalWndProc(Messages::TMessage &Message);
	bool __fastcall IsPortStored(void);
	int __fastcall ReceiveFrameASCII(void *Buffer, int Capacity, unsigned &Timeout, unsigned Silence);
	int __fastcall ReceiveFrameRTU(void *Buffer, int Capacity, unsigned &Timeout, unsigned Silence);
	void __fastcall SetActive(bool Value);
	void __fastcall SetBaudRate(TBaudRate Value);
	void __fastcall SetConnectionMode(TConnectionMode Value);
	void __fastcall SetCustomBaudRate(unsigned Value);
	void __fastcall SetDataBits(TDataBits Value);
	void __fastcall SetDTREnabled(bool Value);
	void __fastcall SetEchoQueryBeforeReply(bool Value);
	void __fastcall SetFlowControl(TFlowControl Value);
	void __fastcall SetHookExistingPort(bool Value);
	void __fastcall SetMaxRetries(TMaxRetries Value);
	void __fastcall SetParity(TParityScheme Value);
	void __fastcall SetPort(AnsiString Value);
	void __fastcall SetRefetchDelay(unsigned Value);
	void __fastcall SetReceiveTimeout(unsigned Value);
	void __fastcall SetRTSEnabled(bool Value);
	void __fastcall SetSendTimeout(unsigned Value);
	void __fastcall SetSilentInterval(unsigned Value);
	void __fastcall SetStopBits(TStopBits Value);
	void __fastcall SetThreadPriority(Classes::TThreadPriority Value);
	void __fastcall SetTransmissionMode(TTransmissionMode Value);
	void __fastcall SetTurnaroundDelay(unsigned Value);
	void __fastcall UpdateDCB(void);
	void __fastcall WaitForIdleState(void);
	
protected:
	Byte __fastcall AcquireModbusCommand(TModbusBuffer* Buffer);
	Byte __fastcall AcquireServerAddress(TModbusBuffer* Buffer);
	void __fastcall AcquireServerException(TModbusBuffer* Buffer, TServerException &Exception, Byte &ExceptionCode);
	void __fastcall CheckClosed(void);
	void __fastcall CheckOpened(void);
	void __fastcall ClearDeviceBuffers(bool RX, bool TX);
	void __fastcall DecodeFrame(const void *Source, TModbusBuffer* Dest, int SourceSize);
	int __fastcall DetermineDeviceBufferSize(void);
	int __fastcall DetermineErrorCheckSize(void);
	int __fastcall DetermineHeaderSize(void);
	int __fastcall DetermineInterimBufferSize(void);
	int __fastcall DetermineMaximumFrameSize(void);
	int __fastcall DetermineMinimumQuerySize(void);
	int __fastcall DetermineMinimumReplySize(void);
	DYNAMIC void __fastcall DoAfterClose(void);
	DYNAMIC void __fastcall DoAfterOpen(void);
	DYNAMIC void __fastcall DoBeforeClose(void);
	DYNAMIC void __fastcall DoBeforeOpen(void);
	DYNAMIC void __fastcall DoFrameReceive(const TFrameData Data);
	DYNAMIC void __fastcall DoFrameSend(const TFrameData Data);
	DYNAMIC unsigned __fastcall DoGetHookedPortHandle(void);
	int __fastcall EncodeFrame(TModbusBuffer* Source, void *Dest, int DestCapacity);
	bool __fastcall ErrorChecksEqual(TModbusBuffer* Buffer);
	bool __fastcall ExamineInputBuffer(/* out */ int &UnreadCount);
	bool __fastcall FramesMatch(TModbusBuffer* QueryBuffer, TModbusBuffer* ReplyBuffer, bool PromiscuousMode);
	bool __fastcall HeadersMatch(TModbusBuffer* QueryBuffer, TModbusBuffer* ReplyBuffer);
	void __fastcall InternalClose(void);
	void __fastcall InternalOpen(void);
	bool __fastcall InternalReceiveFrame(void *Buffer, int Size);
	bool __fastcall IsEcho(TModbusBuffer* QueryBuffer, TModbusBuffer* ReplyBuffer);
	bool __fastcall IsExceptionReply(TModbusBuffer* Buffer);
	bool __fastcall IsValidFrame(TModbusBuffer* Buffer);
	virtual void __fastcall Loaded(void);
	int __fastcall ReceiveFrame(void *Buffer, int Capacity, unsigned &Timeout);
	bool __fastcall SendFrame(const void *Buffer, int Size, unsigned Timeout);
	bool __fastcall WaitForData(unsigned Timeout);
	
public:
	__fastcall virtual TModbusConnection(Classes::TComponent* AOwner);
	__fastcall virtual ~TModbusConnection(void);
	void __fastcall Close(void);
	int __fastcall CountPendingTransactions(TModbusClient* Client = (TModbusClient*)(0x0));
	void __fastcall DiscardPendingTransactions(TModbusClient* Client = (TModbusClient*)(0x0));
	void __fastcall EmitErrorCheck(TModbusBuffer* Buffer);
	void __fastcall EmitHeader(TModbusClient* Client, TModbusBuffer* Buffer)/* overload */;
	void __fastcall EmitHeader(TModbusServer* Server, TModbusBuffer* Buffer)/* overload */;
	void __fastcall EnqueueTransaction(TModbusTransaction* Transaction);
	unsigned __fastcall GetNextUniqueID(void);
	void __fastcall Open(void);
	void __fastcall ProcessRemoteTransaction(TModbusTransaction* Transaction);
	void __fastcall RegisterClient(TModbusClient* Client);
	void __fastcall RegisterServer(TModbusServer* Server);
	void __fastcall UnregisterClient(TModbusClient* Client);
	void __fastcall UnregisterServer(TModbusServer* Server);
	unsigned __fastcall WriteMultipleCoils(Word StartBit, bool const * BitValues, const int BitValues_Size, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteMultipleRegisters(Word StartReg, Word const * RegValues, const int RegValues_Size, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteSingleCoil(Word BitAddr, bool BitValue, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteSingleRegister(Word RegAddr, Word RegValue, void * UserData = (void *)(0x0));
	__property int ClientCount = {read=GetClientCount, nodefault};
	__property TModbusClient* Clients[int Index] = {read=GetClient};
	__property unsigned RealSilentInterval = {read=GetRealSilentInterval, nodefault};
	__property int ServerCount = {read=GetServerCount, nodefault};
	__property TModbusServer* Servers[int Index] = {read=GetServer};
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property TBaudRate BaudRate = {read=FBaudRate, write=SetBaudRate, default=8};
	__property TConnectionMode ConnectionMode = {read=FConnectionMode, write=SetConnectionMode, default=0};
	__property unsigned CustomBaudRate = {read=FCustomBaudRate, write=SetCustomBaudRate, default=19200};
	__property TDataBits DataBits = {read=FDataBits, write=SetDataBits, default=1};
	__property bool DTREnabled = {read=FDTREnabled, write=SetDTREnabled, default=1};
	__property bool EchoQueryBeforeReply = {read=FEchoQueryBeforeReply, write=SetEchoQueryBeforeReply, default=0};
	__property TFlowControl FlowControl = {read=FFlowControl, write=SetFlowControl, default=0};
	__property bool HookExistingPort = {read=FHookExistingPort, write=SetHookExistingPort, default=0};
	__property TMaxRetries MaxRetries = {read=GetMaxRetries, write=SetMaxRetries, default=1};
	__property Classes::TNotifyEvent OnAfterClose = {read=FOnAfterClose, write=FOnAfterClose};
	__property Classes::TNotifyEvent OnAfterOpen = {read=FOnAfterOpen, write=FOnAfterOpen};
	__property Classes::TNotifyEvent OnBeforeClose = {read=FOnBeforeClose, write=FOnBeforeClose};
	__property Classes::TNotifyEvent OnBeforeOpen = {read=FOnBeforeOpen, write=FOnBeforeOpen};
	__property TFrameDataEvent OnFrameReceive = {read=FOnFrameReceive, write=FOnFrameReceive};
	__property TFrameDataEvent OnFrameSend = {read=FOnFrameSend, write=FOnFrameSend};
	__property TGetHookedPortHandleEvent OnGetHookedPortHandle = {read=FOnGetHookedPortHandle, write=FOnGetHookedPortHandle};
	__property TParityScheme Parity = {read=FParity, write=SetParity, default=2};
	__property AnsiString Port = {read=FPort, write=SetPort, stored=IsPortStored};
	__property unsigned ReceiveTimeout = {read=GetReceiveTimeout, write=SetReceiveTimeout, default=1000};
	__property unsigned RefetchDelay = {read=GetRefetchDelay, write=SetRefetchDelay, default=0};
	__property bool RTSEnabled = {read=FRTSEnabled, write=SetRTSEnabled, default=1};
	__property unsigned SendTimeout = {read=GetSendTimeout, write=SetSendTimeout, default=1000};
	__property unsigned SilentInterval = {read=FSilentInterval, write=SetSilentInterval, default=4};
	__property TStopBits StopBits = {read=FStopBits, write=SetStopBits, default=0};
	__property Classes::TThreadPriority ThreadPriority = {read=FThreadPriority, write=SetThreadPriority, default=3};
	__property TTransmissionMode TransmissionMode = {read=FTransmissionMode, write=SetTransmissionMode, default=0};
	__property unsigned TurnaroundDelay = {read=GetTurnaroundDelay, write=SetTurnaroundDelay, default=100};
};


class PASCALIMPLEMENTATION TModbusClient : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TModbusConnection* FConnection;
	TMultipleBitsAccessEvent FOnCoilsRead;
	TCustomTransactionCompleteEvent FOnCustomTransactionComplete;
	TDiagnosticsEvent FOnDiagnostics;
	TMultipleBitsAccessEvent FOnDiscreteInputsRead;
	TExceptionStatusReadEvent FOnExceptionStatusRead;
	TFileRecordAccessEvent FOnFileRecordRead;
	TFileRecordAccessEvent FOnFileRecordWrite;
	TMultipleRegistersAccessEvent FOnHoldingRegistersRead;
	TMultipleRegistersAccessEvent FOnInputRegistersRead;
	TMultipleBitsAccessEvent FOnMultipleCoilsWrite;
	TMultipleRegistersAccessEvent FOnMultipleRegistersWrite;
	TServerIdentificationReportEvent FOnServerIdentificationReport;
	TSingleCoilWriteEvent FOnSingleCoilWrite;
	TSingleRegisterMaskWriteEvent FOnSingleRegisterMaskWrite;
	TSingleRegisterWriteEvent FOnSingleRegisterWrite;
	TTranslateExceptionCodeEvent FOnTranslateExceptionCode;
	Byte FServerAddress;
	void __fastcall DoneCustomTransaction(TModbusTransaction* Transaction);
	void __fastcall DoneDiagnostics(TModbusTransaction* Transaction);
	void __fastcall DoneReadDiscreteBits(TModbusTransaction* Transaction, bool Coils);
	void __fastcall DoneReadExceptionStatus(TModbusTransaction* Transaction);
	void __fastcall DoneReadFileRecord(TModbusTransaction* Transaction);
	void __fastcall DoneReadModbusRegisters(TModbusTransaction* Transaction, bool HoldingRegisters);
	void __fastcall DoneReportServerID(TModbusTransaction* Transaction);
	void __fastcall DoneMaskWriteSingleRegister(TModbusTransaction* Transaction);
	void __fastcall DoneWriteFileRecord(TModbusTransaction* Transaction);
	void __fastcall DoneWriteMultipleCoils(TModbusTransaction* Transaction);
	void __fastcall DoneWriteMultipleRegisters(TModbusTransaction* Transaction);
	void __fastcall DoneWriteSingleCoil(TModbusTransaction* Transaction);
	void __fastcall DoneWriteSingleRegister(TModbusTransaction* Transaction);
	void __fastcall SetConnection(TModbusConnection* Value);
	void __fastcall SetServerAddress(Byte Value);
	
protected:
	DYNAMIC void __fastcall DoCoilsRead(const TTransactionInfo &Info, Word StartBit, Word BitCount, const TBitValues BitValues);
	DYNAMIC void __fastcall DoCustomTransactionComplete(const TTransactionInfo &Info, Byte Command, const AnsiString RequestData, const AnsiString ResponseData);
	DYNAMIC void __fastcall DoDiagnostics(const TTransactionInfo &Info, TDiagnosticAction Action, Word Result);
	DYNAMIC void __fastcall DoDiscreteInputsRead(const TTransactionInfo &Info, Word StartBit, Word BitCount, const TBitValues BitValues);
	DYNAMIC void __fastcall DoExceptionStatusRead(const TTransactionInfo &Info, const TExceptionStatusValues StatusValues);
	DYNAMIC void __fastcall DoFileRecordRead(const TTransactionInfo &Info, TModbusFileRecordList* FileRecList);
	DYNAMIC void __fastcall DoFileRecordWrite(const TTransactionInfo &Info, TModbusFileRecordList* FileRecList);
	DYNAMIC void __fastcall DoHoldingRegistersRead(const TTransactionInfo &Info, Word StartReg, Word RegCount, const TRegValues RegValues);
	DYNAMIC void __fastcall DoInputRegistersRead(const TTransactionInfo &Info, Word StartReg, Word RegCount, const TRegValues RegValues);
	DYNAMIC void __fastcall DoMultipleCoilsWrite(const TTransactionInfo &Info, Word StartBit, Word BitCount, const TBitValues BitValues);
	DYNAMIC void __fastcall DoMultipleRegistersWrite(const TTransactionInfo &Info, Word StartReg, Word RegCount, const TRegValues RegValues);
	DYNAMIC void __fastcall DoServerIdentificationReport(const TTransactionInfo &Info, int Count, const TServerIdentificationData Data);
	DYNAMIC void __fastcall DoSingleCoilWrite(const TTransactionInfo &Info, Word BitAddr, bool BitValue);
	DYNAMIC void __fastcall DoSingleRegisterMaskWrite(const TTransactionInfo &Info, Word RegAddr, Word AndMask, Word OrMask);
	DYNAMIC void __fastcall DoSingleRegisterWrite(const TTransactionInfo &Info, Word RegAddr, Word RegValue);
	DYNAMIC void __fastcall DoTranslateExceptionCode(Byte ExceptionCode, AnsiString &Description);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	__fastcall virtual TModbusClient(Classes::TComponent* AOwner);
	__fastcall virtual ~TModbusClient(void);
	void __fastcall CheckConnected(void);
	void __fastcall CheckDisconnected(void);
	unsigned __fastcall Diagnostics(TDiagnosticAction Action, void * UserData = (void *)(0x0));
	void __fastcall DoneTransaction(TModbusTransaction* Transaction);
	AnsiString __fastcall ExceptionCodeToStr(Byte ExceptionCode);
	unsigned __fastcall InitCustomTransaction(Byte Command, const AnsiString RequestData, bool PromiscuousMode, void * UserData = (void *)(0x0));
	unsigned __fastcall MaskWriteSingleRegister(Word RegAddr, Word AndMask, Word OrMask, void * UserData = (void *)(0x0));
	unsigned __fastcall ReadCoils(Word StartBit, Word BitCount, void * UserData = (void *)(0x0));
	unsigned __fastcall ReadDiscreteInputs(Word StartBit, Word BitCount, void * UserData = (void *)(0x0));
	unsigned __fastcall ReadExceptionStatus(void * UserData = (void *)(0x0));
	unsigned __fastcall ReadFileRecord(TModbusFileRecordList* FileRecList, void * UserData = (void *)(0x0));
	unsigned __fastcall ReadHoldingRegisters(Word StartReg, Word RegCount, void * UserData = (void *)(0x0));
	unsigned __fastcall ReadInputRegisters(Word StartReg, Word RegCount, void * UserData = (void *)(0x0));
	unsigned __fastcall ReportServerID(void * UserData = (void *)(0x0));
	unsigned __fastcall WriteFileRecord(TModbusFileRecordList* FileRecList, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteMultipleCoils(Word StartBit, bool const * BitValues, const int BitValues_Size, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteMultipleRegisters(Word StartReg, Word const * RegValues, const int RegValues_Size, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteSingleCoil(Word BitAddr, bool BitValue, void * UserData = (void *)(0x0));
	unsigned __fastcall WriteSingleRegister(Word RegAddr, Word RegValue, void * UserData = (void *)(0x0));
	
__published:
	__property TModbusConnection* Connection = {read=FConnection, write=SetConnection};
	__property TMultipleBitsAccessEvent OnCoilsRead = {read=FOnCoilsRead, write=FOnCoilsRead};
	__property TCustomTransactionCompleteEvent OnCustomTransactionComplete = {read=FOnCustomTransactionComplete, write=FOnCustomTransactionComplete};
	__property TDiagnosticsEvent OnDiagnostics = {read=FOnDiagnostics, write=FOnDiagnostics};
	__property TMultipleBitsAccessEvent OnDiscreteInputsRead = {read=FOnDiscreteInputsRead, write=FOnDiscreteInputsRead};
	__property TExceptionStatusReadEvent OnExceptionStatusRead = {read=FOnExceptionStatusRead, write=FOnExceptionStatusRead};
	__property TFileRecordAccessEvent OnFileRecordRead = {read=FOnFileRecordRead, write=FOnFileRecordRead};
	__property TFileRecordAccessEvent OnFileRecordWrite = {read=FOnFileRecordWrite, write=FOnFileRecordWrite};
	__property TMultipleRegistersAccessEvent OnHoldingRegistersRead = {read=FOnHoldingRegistersRead, write=FOnHoldingRegistersRead};
	__property TMultipleRegistersAccessEvent OnInputRegistersRead = {read=FOnInputRegistersRead, write=FOnInputRegistersRead};
	__property TMultipleBitsAccessEvent OnMultipleCoilsWrite = {read=FOnMultipleCoilsWrite, write=FOnMultipleCoilsWrite};
	__property TMultipleRegistersAccessEvent OnMultipleRegistersWrite = {read=FOnMultipleRegistersWrite, write=FOnMultipleRegistersWrite};
	__property TServerIdentificationReportEvent OnServerIdentificationReport = {read=FOnServerIdentificationReport, write=FOnServerIdentificationReport};
	__property TSingleCoilWriteEvent OnSingleCoilWrite = {read=FOnSingleCoilWrite, write=FOnSingleCoilWrite};
	__property TSingleRegisterMaskWriteEvent OnSingleRegisterMaskWrite = {read=FOnSingleRegisterMaskWrite, write=FOnSingleRegisterMaskWrite};
	__property TSingleRegisterWriteEvent OnSingleRegisterWrite = {read=FOnSingleRegisterWrite, write=FOnSingleRegisterWrite};
	__property TTranslateExceptionCodeEvent OnTranslateExceptionCode = {read=FOnTranslateExceptionCode, write=FOnTranslateExceptionCode};
	__property Byte ServerAddress = {read=FServerAddress, write=SetServerAddress, default=1};
};


typedef void __fastcall (__closure *TAcceptCommandEvent)(TModbusServer* Sender, Byte Command, bool &Accept);

#pragma option push -b-
enum TItemWriteStatus { iwsIllegalAddress, iwsIllegalValue, iwsAllowWrite };
#pragma option pop

typedef void __fastcall (__closure *TCanReadDiscreteBitEvent)(TModbusServer* Sender, Word BitAddr, bool &Allow);

typedef void __fastcall (__closure *TCanWriteCoilEvent)(TModbusServer* Sender, Word BitAddr, bool BitValue, TItemWriteStatus &Status);

typedef void __fastcall (__closure *TGetDiscreteBitValueEvent)(TModbusServer* Sender, Word BitAddr, bool &BitValue);

typedef void __fastcall (__closure *TSetCoilValueEvent)(TModbusServer* Sender, Word BitAddr, bool BitValue);

typedef void __fastcall (__closure *TCanReadRegisterEvent)(TModbusServer* Sender, Word RegAddr, bool &Allow);

typedef void __fastcall (__closure *TCanWriteRegisterEvent)(TModbusServer* Sender, Word RegAddr, Word RegValue, TItemWriteStatus &Status);

typedef void __fastcall (__closure *TGetRegisterValueEvent)(TModbusServer* Sender, Word RegAddr, Word &RegValue);

typedef void __fastcall (__closure *TSetRegisterValueEvent)(TModbusServer* Sender, Word RegAddr, Word RegValue);

class PASCALIMPLEMENTATION TModbusServer : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TModbusTransaction* FActiveTransaction;
	Byte FAddress;
	TModbusConnection* FConnection;
	TAcceptCommandEvent FOnAcceptCommand;
	TCanReadDiscreteBitEvent FOnCanReadCoil;
	TCanReadDiscreteBitEvent FOnCanReadDiscreteInput;
	TCanReadRegisterEvent FOnCanReadHoldingRegister;
	TCanReadRegisterEvent FOnCanReadInputRegister;
	TCanWriteCoilEvent FOnCanWriteCoil;
	TCanWriteRegisterEvent FOnCanWriteHoldingRegister;
	TGetDiscreteBitValueEvent FOnGetCoilValue;
	TGetDiscreteBitValueEvent FOnGetDiscreteInputValue;
	TGetRegisterValueEvent FOnGetHoldingRegisterValue;
	TGetRegisterValueEvent FOnGetInputRegisterValue;
	TSetCoilValueEvent FOnSetCoilValue;
	TSetRegisterValueEvent FOnSetHoldingRegisterValue;
	void __fastcall BuildExceptionReply(TModbusBuffer* Buffer, Byte Command, TServerException Exception);
	void __fastcall ProcessReadDiscreteBits(TModbusTransaction* Transaction, bool Coils);
	void __fastcall ProcessReadModbusRegisters(TModbusTransaction* Transaction, bool HoldingRegisters);
	void __fastcall ProcessWriteMultipleCoils(TModbusTransaction* Transaction);
	void __fastcall ProcessWriteMultipleRegisters(TModbusTransaction* Transaction);
	void __fastcall ProcessWriteSingleCoil(TModbusTransaction* Transaction);
	void __fastcall ProcessWriteSingleRegister(TModbusTransaction* Transaction);
	void __fastcall SetAddress(Byte Value);
	void __fastcall SetConnection(TModbusConnection* Value);
	
protected:
	DYNAMIC bool __fastcall DoAcceptCommand(Byte Command);
	DYNAMIC bool __fastcall DoCanReadCoil(Word BitAddr);
	DYNAMIC bool __fastcall DoCanReadDiscreteInput(Word BitAddr);
	DYNAMIC bool __fastcall DoCanReadHoldingRegister(Word RegAddr);
	DYNAMIC bool __fastcall DoCanReadInputRegister(Word RegAddr);
	DYNAMIC TItemWriteStatus __fastcall DoCanWriteCoil(Word BitAddr, bool BitValue);
	DYNAMIC TItemWriteStatus __fastcall DoCanWriteHoldingRegister(Word RegAddr, Word RegValue);
	DYNAMIC bool __fastcall DoGetCoilValue(Word BitAddr);
	DYNAMIC bool __fastcall DoGetDiscreteInputValue(Word BitAddr);
	DYNAMIC Word __fastcall DoGetHoldingRegisterValue(Word RegAddr);
	DYNAMIC Word __fastcall DoGetInputRegisterValue(Word RegAddr);
	DYNAMIC void __fastcall DoSetCoilValue(Word BitAddr, bool BitValue);
	DYNAMIC void __fastcall DoSetHoldingRegisterValue(Word RegAddr, Word RegValue);
	
public:
	__fastcall virtual TModbusServer(Classes::TComponent* AOwner);
	__fastcall virtual ~TModbusServer(void);
	void __fastcall CheckActiveTransaction(void);
	void __fastcall CheckConnected(void);
	void __fastcall EmitExceptionReply(TServerException Exception);
	void __fastcall ProcessTransaction(TModbusTransaction* Transaction);
	
__published:
	__property Byte Address = {read=FAddress, write=SetAddress, default=1};
	__property TModbusConnection* Connection = {read=FConnection, write=SetConnection};
	__property TAcceptCommandEvent OnAcceptCommand = {read=FOnAcceptCommand, write=FOnAcceptCommand};
	__property TCanReadDiscreteBitEvent OnCanReadCoil = {read=FOnCanReadCoil, write=FOnCanReadCoil};
	__property TCanReadDiscreteBitEvent OnCanReadDiscreteInput = {read=FOnCanReadDiscreteInput, write=FOnCanReadDiscreteInput};
	__property TCanReadRegisterEvent OnCanReadHoldingRegister = {read=FOnCanReadHoldingRegister, write=FOnCanReadHoldingRegister};
	__property TCanReadRegisterEvent OnCanReadInputRegister = {read=FOnCanReadInputRegister, write=FOnCanReadInputRegister};
	__property TCanWriteCoilEvent OnCanWriteCoil = {read=FOnCanWriteCoil, write=FOnCanWriteCoil};
	__property TCanWriteRegisterEvent OnCanWriteHoldingRegister = {read=FOnCanWriteHoldingRegister, write=FOnCanWriteHoldingRegister};
	__property TGetDiscreteBitValueEvent OnGetCoilValue = {read=FOnGetCoilValue, write=FOnGetCoilValue};
	__property TGetDiscreteBitValueEvent OnGetDiscreteInputValue = {read=FOnGetDiscreteInputValue, write=FOnGetDiscreteInputValue};
	__property TGetRegisterValueEvent OnGetHoldingRegisterValue = {read=FOnGetHoldingRegisterValue, write=FOnGetHoldingRegisterValue};
	__property TGetRegisterValueEvent OnGetInputRegisterValue = {read=FOnGetInputRegisterValue, write=FOnGetInputRegisterValue};
	__property TSetCoilValueEvent OnSetCoilValue = {read=FOnSetCoilValue, write=FOnSetCoilValue};
	__property TSetRegisterValueEvent OnSetHoldingRegisterValue = {read=FOnSetHoldingRegisterValue, write=FOnSetHoldingRegisterValue};
};


typedef TFrameData *PFrameData;

//-- var, const, procedure ---------------------------------------------------
#define ModLinkVersion "2.7 (2006-03-09)"
static const Shortint MinQueryPDUSize = 0x1;
static const Shortint MinReplyPDUSize = 0x2;
static const Byte MaxFramePDUSize = 0xfd;
static const Shortint MinQueryADUSizeRTU = 0x4;
static const Shortint MinReplyADUSizeRTU = 0x5;
static const Word MaxFrameADUSizeRTU = 0x100;
static const Shortint MinQueryADUSizeASCII = 0x3;
static const Shortint MinReplyADUSizeASCII = 0x4;
static const Byte MaxFrameADUSizeASCII = 0xff;
static const Shortint Cmd_ReadCoils = 0x1;
static const Shortint Cmd_ReadDiscreteInputs = 0x2;
static const Shortint Cmd_ReadHoldingRegisters = 0x3;
static const Shortint Cmd_ReadInputRegisters = 0x4;
static const Shortint Cmd_WriteSingleCoil = 0x5;
static const Shortint Cmd_WriteSingleRegister = 0x6;
static const Shortint Cmd_ReadExceptionStatus = 0x7;
static const Shortint Cmd_Diagnostics = 0x8;
static const Shortint Cmd_WriteMultipleCoils = 0xf;
static const Shortint Cmd_WriteMultipleRegisters = 0x10;
static const Shortint Cmd_ReportServerID = 0x11;
static const Shortint Cmd_ReadFileRecord = 0x14;
static const Shortint Cmd_WriteFileRecord = 0x15;
static const Shortint Cmd_MaskWriteRegister = 0x16;
static const Shortint Subcmd_Diagnostics_ReturnQueryData = 0x0;
static const Shortint Subcmd_Diagnostics_RestartCommsOption = 0x1;
static const Shortint Subcmd_Diagnostics_RestartCommsOptionAndClearEventLog = 0x1;
static const Shortint Subcmd_Diagnostics_ReturnDiagnosticRegister = 0x2;
static const Shortint Subcmd_Diagnostics_ForceListenOnlyMode = 0x4;
static const Shortint Subcmd_Diagnostics_ClearCountersAndDiagnosticRegister = 0xa;
static const Shortint Subcmd_Diagnostics_ReturnBusMessageCount = 0xb;
static const Shortint Subcmd_Diagnostics_ReturnBusCommErrorCount = 0xc;
static const Shortint Subcmd_Diagnostics_ReturnBusExceptionErrorCount = 0xd;
static const Shortint Subcmd_Diagnostics_ReturnServerMessageCount = 0xe;
static const Shortint Subcmd_Diagnostics_ReturnServerNoReplyCount = 0xf;
static const Shortint Subcmd_Diagnostics_ReturnServerNegativeAcknowledgeCount = 0x10;
static const Shortint Subcmd_Diagnostics_ReturnServerBusyCount = 0x11;
static const Shortint Subcmd_Diagnostics_ReturnBusCharacterOverrunCount = 0x12;
static const Shortint Subcmd_Diagnostics_ClearOverrunCounterAndFlag = 0x14;
extern PACKAGE void __fastcall EnumSerialPorts(Classes::TStrings* Dest);
extern PACKAGE Word __fastcall SmallInt2Mod(short Number);
extern PACKAGE void __fastcall LongInt2Mod(int Number, Word &RegValue1, Word &RegValue2, bool BigEndian = false);
extern PACKAGE void __fastcall LongWord2Mod(unsigned Number, Word &RegValue1, Word &RegValue2, bool BigEndian = false);
extern PACKAGE Word __fastcall ScaledFloat2Mod(const float Number, int Decimals);
extern PACKAGE void __fastcall Single2Mod(const float Number, Word &RegValue1, Word &RegValue2, bool BigEndian = false);
extern PACKAGE void __fastcall Double2Mod(const double Number, Word &RegValue1, Word &RegValue2, Word &RegValue3, Word &RegValue4, bool BigEndian = false);
extern PACKAGE short __fastcall Mod2SmallInt(Word RegValue);
extern PACKAGE int __fastcall Mod2LongInt(Word RegValue1, Word RegValue2, bool BigEndian = false);
extern PACKAGE unsigned __fastcall Mod2LongWord(Word RegValue1, Word RegValue2, bool BigEndian = false);
extern PACKAGE float __fastcall Mod2ScaledFloat(Word RegValue, int Decimals);
extern PACKAGE float __fastcall Mod2Single(Word RegValue1, Word RegValue2, bool BigEndian = false);
extern PACKAGE double __fastcall Mod2Double(Word RegValue1, Word RegValue2, Word RegValue3, Word RegValue4, bool BigEndian = false);

}	/* namespace Modlink */
using namespace Modlink;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Modlink
